/*
 *  Copyright (C) 2014-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ModelCarControl.h 49 2015-04-24 05:15:03Z honda $
 */  

/*
 *		CDD SW-C CddControllerѤε
 */

#include "Rte_CddController.h"
#include "ModelCarControl.h"
#include "t_syslog.h"
#include "rcb3.h"

/*
 *  CDD SW-C CddControllerѤν
 */
void
CddControllerInit(void)
{
	tInitSBDBTUart();
	rcb3_Init();
}

#ifdef TOPPERS_WITH_DISP
/*
 *  ɽϢ
 */
#define DISP_MSG_LEN			8
#define DISP_MSG_HEADER_1		0xF0

typedef enum disp_st {
	DISP_ST_HEADER_1,
	DISP_ST_CYCLE_1,
	DISP_ST_CYCLE_2,
	DISP_ST_INFO_1,
	DISP_ST_INFO_2,
	DISP_ST_INFO_3,
	DISP_ST_INFO_4,
	DISP_ST_SUM
} disp_st_type;

static disp_st_type	s_disp_st = DISP_ST_HEADER_1;
static uint8		s_disp_rmsg_cnt;
static uint8		g_disp_rmsg[DISP_MSG_LEN];

static boolean disp_AddReceivedByte(uint8 c);
#endif /* TOPPERS_WITH_DISP */


/* ̵(Ƥʤ) */
#define NOT_RECEIVE_COMMAND		0xFFFFFFFFU

/* ⡼ */
typedef enum {
	RX_MODE_INIT,
	RX_MODE_RCB3,
#ifdef TOPPERS_WITH_DISP
	RX_MODE_DISP
#endif /* TOPPERS_WITH_DISP */
} rx_mode_type;

/* TRUEǽ뤳Ȥͤʤ褦ˤ */
static IDT_RCB3		RCB3CommandData;
static boolean		RCB3CommandGotFlg = TRUE;
#ifdef TOPPERS_WITH_DISP
static IDT_Disp		DisplayCommandData;
static boolean		DisplayCommandGotFlg = TRUE;
#endif /* TOPPERS_WITH_DISP */

static rx_mode_type rx_mode = RX_MODE_INIT;

/*
 *  RunnableEntity(ڥ졼ƽФ)
 */
void
GetRCB3Command(IDT_RCB3 *command)
{
	if (RCB3CommandGotFlg == FALSE) {
		*command = RCB3CommandData;
		RCB3CommandGotFlg = TRUE;
	}
	else {
		*command = NOT_RECEIVE_COMMAND;
	}
}

/*
 *  MessageParserʥ֥
 */
void
MessageParser(void)
{
	uint8 c;

	while (tReceiveSBDBTUart(&c, 1)) {
		switch (rx_mode) {
		case RX_MODE_INIT:
			if (c == RCB3_MSG_HEADER_1) {
				/* RCB3ǡ */
				(void) rcb3_AddReceivedByte(c);
				rx_mode = RX_MODE_RCB3;
			}
#ifdef TOPPERS_WITH_DISP
			else if (c == DISP_MSG_HEADER_1) {
				/* ɽǡ */
				(void) disp_AddReceivedByte(c);
				rx_mode = RX_MODE_DISP;
			}
#endif /* TOPPERS_WITH_DISP */
			else {
				syslog(LOG_INFO, "## Header Error (0x%x)", c);
			}
			break;
		case RX_MODE_RCB3:
			if (rcb3_AddReceivedByte(c)) {
				/* RCB3ǡλ */
				RCB3CommandData = (IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_L];         /* ܥ1 */
				RCB3CommandData += ((IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_H]) << 8U;/* ܥ2 */
				RCB3CommandData += ((IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_L_ANALOG_LR]) << 16U;  /* ʥ1 */
				RCB3CommandData += ((IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_R_ANALOG_UD]) << 24U;  /* ʥ4 */
				RCB3CommandGotFlg = FALSE;
				rx_mode = RX_MODE_INIT;
			}
			break;
#ifdef TOPPERS_WITH_DISP
		case RX_MODE_DISP:
			if (disp_AddReceivedByte(c)) {
				/* ɽǡλ */
				DisplayCommandData = (IDT_Disp) g_disp_rmsg[1];             /* ɽ1 */
				DisplayCommandData += ((IDT_Disp) g_disp_rmsg[2]) << 8U;    /* ɽ2 */
				DisplayCommandData += ((IDT_Disp) g_disp_rmsg[3]) << 16U;   /* ɽ */
				DisplayCommandGotFlg = FALSE;
				rx_mode = RX_MODE_INIT;
			}
			break;
#endif /* TOPPERS_WITH_DISP */
		}
	}
}

/*
 *  rcb3_AddReceivedByteΥ顼Хå
 */
void
rcb3_ErrorCb(uint8 sum, uint8 recv_sum, uint8 *p_rcb3_rmsg)
{
	uint32 i;

	rx_mode = RX_MODE_INIT;
	syslog(LOG_INFO, "## RCB3 Sum Error: 0x%x != 0x%x", sum, recv_sum);
	for (i = 0; i < RCB3_MSG_LEN; i++) {
		syslog(LOG_INFO, "## rcb3_rmsg[%d]: 0x%x", i, p_rcb3_rmsg[i]);
	}
}

#ifdef TOPPERS_WITH_DISP
void
GetDisplayCommand(IDT_Disp *command)
{
	if (DisplayCommandGotFlg == FALSE) {
		*command = DisplayCommandData;
		DisplayCommandGotFlg = TRUE;
	}
	else {
		*command = NOT_RECEIVE_COMMAND;
	}
}

boolean
disp_AddReceivedByte(uint8 c)
{
	boolean rval = FALSE;
	uint8	i;
	uint8	sum = 0;

	switch (s_disp_st) {
	case DISP_ST_HEADER_1:
		if (c == DISP_MSG_HEADER_1) {
			s_disp_rmsg_cnt = 0;
			g_disp_rmsg[s_disp_rmsg_cnt++] = c;
			s_disp_st = DISP_ST_CYCLE_1;
		}
		break;
	case DISP_ST_CYCLE_1:
		g_disp_rmsg[s_disp_rmsg_cnt++] = c;
		s_disp_st = DISP_ST_CYCLE_2;
		break;
	case DISP_ST_CYCLE_2:
		g_disp_rmsg[s_disp_rmsg_cnt++] = c;
		s_disp_st = DISP_ST_INFO_1;
		break;
	case DISP_ST_INFO_1:
		g_disp_rmsg[s_disp_rmsg_cnt++] = c;
		s_disp_st = DISP_ST_INFO_2;
		break;
	case DISP_ST_INFO_2:
		g_disp_rmsg[s_disp_rmsg_cnt++] = c;
		s_disp_st = DISP_ST_INFO_3;
		break;
	case DISP_ST_INFO_3:
		g_disp_rmsg[s_disp_rmsg_cnt++] = c;
		s_disp_st = DISP_ST_INFO_4;
		break;
	case DISP_ST_INFO_4:
		g_disp_rmsg[s_disp_rmsg_cnt++] = c;
		s_disp_st = DISP_ST_SUM;
		break;
	case DISP_ST_SUM:
		g_disp_rmsg[s_disp_rmsg_cnt++] = c;
		for (i = 1; i < (DISP_MSG_LEN - 1); i++) {
			sum += g_disp_rmsg[i];
		}
		sum &= 0x7FU;
		if (c == sum) {
			rval = TRUE;
		}
		else {
			rx_mode = RX_MODE_INIT;
			syslog(LOG_INFO, "## Disp Sum Error: 0x%x != 0x%x", sum, c);
			for (i = 0; i < DISP_MSG_LEN; i++) {
				syslog(LOG_INFO, "## g_disp_rmsg[%d]: 0x%x", i, g_disp_rmsg[i]);
			}
		}
		s_disp_st = DISP_ST_HEADER_1;
		break;
	}
	return(rval);
}
#endif /* TOPPERS_WITH_DISP */
